package data.scripts.world;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.RepLevel;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorGeneratorPlugin;
import com.fs.starfarer.api.impl.campaign.ids.Factions;
import com.fs.starfarer.api.impl.campaign.shared.SharedData;
import data.scripts.world.systems.Gemstone;

public class AIW_SectorGen implements SectorGeneratorPlugin {

    @Override
    public void generate(SectorAPI sector) {
        SharedData.getData().getPersonBountyEventData().addParticipatingFaction("spire");
        initFactionRelationships(sector);
        
        new Gemstone().generate(sector);
    }
    
    public static void initFactionRelationships(SectorAPI sector) {
        FactionAPI spire = sector.getFaction("spire");
        
        //spire.setRelationship(Factions.PLAYER, 0);
        spire.setRelationship(Factions.PIRATES, RepLevel.HOSTILE);
        spire.setRelationship(Factions.LUDDIC_CHURCH, RepLevel.SUSPICIOUS);
        
        FactionAPI darkspire = sector.getFaction("darkspire");
        for (FactionAPI faction : Global.getSector().getAllFactions())
        {
            if (faction == darkspire) continue;
            darkspire.setRelationship(faction.getId(), -1f);
        }
    }
}
